import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.WindowObject;
import win32frame.Split;
import std.stdio;
import std.string;
import std.utf;

import SubPanel1 ;
import SubPanel2 ;

class MainPanel : WindowObject {
  SubPanel1  subpanel1 ;
  SubPanel2  subpanel2 ;
  Split      splitbase ;

  this(string name, string ClassName) {
    winc.style          = 0;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = null ;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    //    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    super(name) ;
    this.registwinc() ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      break ;

    case WM_CREATE:
      splitbase = new Split("SplitBase") ;
      splitbase.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      splitbase.setPosition(0,0,640,480) ;
      splitbase.setSashPos(208,50,10000) ;
      addObject( splitbase, cast(HMENU)(0), true, true) ;

      subpanel1 = new SubPanel1("SubPanel1","SubPanel1") ;
      subpanel1.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      subpanel1.setPosition(0,0,256,256) ;
      splitbase.addObject(subpanel1, cast(HMENU)(0)) ;

      subpanel2 = new SubPanel2("SubPanel2","SubPanel2") ;
      subpanel2.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      subpanel2.setPosition(0,0,256,256) ;
      splitbase.addObject(subpanel2, cast(HMENU)(0)) ;

      break ;

    case WM_PAINT:
      PAINTSTRUCT ps;
      HDC hdc;
      hdc = BeginPaint(hwnd, &ps);
      EndPaint(hwnd, &ps);
      break ;

    case WM_COMMAND:
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

}
