import win32.windows;
import std.stdio;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.WindowObject ;


class ComboBox : WindowObject {

  this(string name) {
    winc.lpszClassName  = toUTFz!(wchar*)("COMBOBOX") ;
    setStyle( (WS_CHILD | WS_VISIBLE) ) ;
    super(name) ;
  }

  int addString(string str){
    char[] cstr = str.dup ;
    return( cast(int)sendmsg(CB_ADDSTRING , 0 , cast(LPARAM)(toUTFz!(wchar*)(str))) ) ;
  }

  int delString(int index){
    return( cast(int)sendmsg(CB_DELETESTRING, index, 0) ) ;
  }


  int getCount() {
    return( cast(int)sendmsg(CB_GETCOUNT , 0 , 0) ) ;
  }

  int getCursel() {
    return( cast(int)sendmsg(CB_GETCURSEL , 0 , 0) ) ;
  }

  string getCurLabel() {
    int    cur       = getCursel() ;
    int    label_len = cast(int)sendmsg(CB_GETLBTEXTLEN , cur , 0 )  ;
    string retstr    = "" ;

    if( label_len != CB_ERR ){
      wchar[] strbuf = new wchar[label_len+1] ;
      if( sendmsg(CB_GETLBTEXT, cur, cast(LPARAM)(strbuf.ptr)) != CB_ERR ){
        retstr = toUTF8( strbuf[0..label_len] ) ;
      }
    }
    return( retstr ) ;
  }

  int setCursel(int index) {
    return( cast(int)sendmsg(CB_SETCURSEL , index , 0) ) ;
  }

}
