import win32.windows;
import win32frame.WindowObject ;
import win32frame.Panel;
import std.string;
import std.stdio;
import std.utf;


class ScrollPanel : WindowObject {
  int        scwinX=0 ;
  int        scwinY=0 ;
  int        scwinW=0 ;
  int        scwinH=0 ;
  Panel      panel ;
  SCROLLINFO rollinfo_H ;
  SCROLLINFO rollinfo_V ;
  int        rollstepH   ;
  int        rollstepV   ;
  bool       enbscrollH =true ;
  bool       enbscrollV =true ;
  bool       disnoscroll=false ;

  this(string name, int mode=0) {
    winc.style          = 0;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.lpszMenuName   = null;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.lpszClassName  = toUTFz!(wchar*)("ScrollPanel") ;
    super(name) ;
    this.registwinc() ;
    rollstepH=20 ;
    rollstepV=20 ;
  }

  int setScrollWindow(int x, int y, int w, int h){
    scwinX = x ;
    scwinY = y ;
    scwinW = w ;
    scwinH = h ;
    return(0) ;
  }

  int setEnableScroll(bool enbH, bool enbV){
    enbscrollH=enbH ;
    enbscrollV=enbV ;
    return(0) ;
  }

  int setScrollStep(int stepH, int stepV){
    if( stepH<=0 || stepV<=0) return(-1) ;
    rollstepH=stepH ;
    rollstepV=stepV ;
    return(0) ;
  }

  int setScrollStep(int step){
    if( step<=0) return(-1) ;
    rollstepH=step ;
    rollstepV=step ;
    return(0) ;
  }

  int setDisableNoScroll(bool flag){
    disnoscroll=flag ;
    return(0) ;
  }

  override int addObject(WindowObject WObj, HMENU hmenu, bool fitWidth=false, bool fitHeight=false ){
    if( panel is null ) return(-1) ;
    int ret = panel.addObject(WObj, hmenu, fitWidth, fitHeight) ;
    return( ret ) ;
  }

  int addBasePanel(WindowObject WObj, HMENU hmenu, bool fitWidth=false, bool fitHeight=false ){
    int ret = WObj.create(this.getHWND(), hmenu) ;
    if( WObj.getHWND() != null ){
      WOBJ_List.length = WOBJ_List.length + 1 ;
      WOBJ_List[$-1]=WObj ;
      WOBJ_fit[WObj] = ((fitWidth==true) ? FIT.WIDTH : FIT.NONE) + ((fitHeight==true) ? FIT.HEIGHT : FIT.NONE)  ;
    }
    return( ret ) ;
  }

  override LRESULT preproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){
    case WM_CREATE:

      panel = new Panel("ScrollPanelClient") ;
      panel.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      panel.setPosition(0,0,scwinW,scwinH) ;
      addBasePanel( panel, cast(HMENU)(0), !enbscrollH, !enbscrollV) ;

      if( enbscrollH==true ){
        rollinfo_H.cbSize = SCROLLINFO.sizeof ;
        rollinfo_H.fMask  = SIF_RANGE | SIF_POS | SIF_PAGE | (disnoscroll==true ? SIF_DISABLENOSCROLL : 0) ;
        rollinfo_H.nPos   = 0        ;
        rollinfo_H.nPage  = winW-1   ;
        rollinfo_H.nMin   = 0        ;
        rollinfo_H.nMax   = scwinW-1 ;
        SetScrollInfo(hwnd, SB_HORZ, &rollinfo_H, true) ;
      }
      if( enbscrollV==true ){
        rollinfo_V.cbSize = SCROLLINFO.sizeof ;
        rollinfo_V.fMask  = SIF_RANGE | SIF_POS | SIF_PAGE | (disnoscroll==true ? SIF_DISABLENOSCROLL : 0) ;
        rollinfo_V.nPos   = 0        ;
        rollinfo_V.nPage  = winH-1   ;
        rollinfo_V.nMin   = 0        ;
        rollinfo_V.nMax   = scwinH-1 ;
        SetScrollInfo(hwnd, SB_VERT, &rollinfo_V, true) ;
      }

      RECT rc ;
      GetClientRect( hwnd, &rc ) ;

      _winX=0 ;
      _winY=0 ;
      _winW=rc.right  ;
      _winH=rc.bottom ;

      if( enbscrollH==true ){
        rollinfo_H.fMask  = SIF_RANGE | SIF_PAGE | (disnoscroll==true ? SIF_DISABLENOSCROLL : 0) ;
        rollinfo_H.nPage  = rc.right ;
        rollinfo_H.nMin   = 0        ;
        rollinfo_H.nMax   = scwinW-1 ;
        SetScrollInfo(hwnd, SB_HORZ, &rollinfo_H, true) ;
        rollinfo_H.fMask  = SIF_POS ;
      }
      if( enbscrollV==true ){
        rollinfo_V.fMask  = SIF_RANGE | SIF_PAGE | (disnoscroll==true ? SIF_DISABLENOSCROLL : 0) ;
        rollinfo_V.nPage  = rc.bottom;
        rollinfo_V.nMin   = 0        ;
        rollinfo_V.nMax   = scwinH-1 ;
        SetScrollInfo(hwnd, SB_VERT, &rollinfo_V, true) ;
        rollinfo_V.fMask  = SIF_POS ;
      }
      break ;

    case WM_MOVE :
      _winX=LOWORD(lp) ;
      _winY=HIWORD(lp) ;
      break ;

    case WM_SIZE :
      _winW=LOWORD(lp) ;
      _winH=HIWORD(lp) ;
      RECT rc_pcl ; GetClientRect( hwnd, &rc_pcl ) ;
      RECT rc_pwd ; GetWindowRect( hwnd, &rc_pwd ) ;
      RECT nullRC ;
      foreach_reverse( i, WOBJ ; WOBJ_List ){
        if( WOBJ !is null ){
          WOBJfitting(WOBJ, nullRC, rc_pwd, rc_pcl) ;
        }
      }

      int w=LOWORD(lp) ;
      int h=HIWORD(lp) ;
      if( enbscrollH==true ){
        rollinfo_H.fMask  = SIF_RANGE | SIF_PAGE | (disnoscroll==true ? SIF_DISABLENOSCROLL : 0) ;
        rollinfo_H.nPage  = w        ;
        rollinfo_H.nMin   = 0        ;
        rollinfo_H.nMax   = scwinW-1 ;
        SetScrollInfo(hwnd, SB_HORZ, &rollinfo_H, true) ;
        rollinfo_H.fMask  = SIF_POS ;
      }
      if( enbscrollV==true ){
        rollinfo_V.fMask  = SIF_RANGE | SIF_PAGE | (disnoscroll==true ? SIF_DISABLENOSCROLL : 0) ;
        rollinfo_V.nPage  = h        ;
        rollinfo_V.nMin   = 0        ;
        rollinfo_V.nMax   = scwinH-1 ;
        SetScrollInfo(hwnd, SB_VERT, &rollinfo_V, true) ;
        rollinfo_V.fMask  = SIF_POS ;
      }

      RECT rc ;
      GetClientRect( hwnd, &rc ) ;

      if( enbscrollH==true ){
        rollinfo_H.fMask  = SIF_RANGE | SIF_PAGE | (disnoscroll==true ? SIF_DISABLENOSCROLL : 0) ;
        rollinfo_H.nPage  = rc.right ;
        rollinfo_H.nMin   = 0        ;
        rollinfo_H.nMax   = scwinW-1 ;
        SetScrollInfo(hwnd, SB_HORZ, &rollinfo_H, true) ;
        rollinfo_H.fMask  = SIF_POS ;
      }
      if( enbscrollV==true ){
        rollinfo_V.fMask  = SIF_RANGE | SIF_PAGE | (disnoscroll==true ? SIF_DISABLENOSCROLL : 0) ;
        rollinfo_V.nPage  = rc.bottom;
        rollinfo_V.nMin   = 0        ;
        rollinfo_V.nMax   = scwinH-1 ;
        SetScrollInfo(hwnd, SB_VERT, &rollinfo_V, true) ;
        rollinfo_V.fMask  = SIF_POS ;
      }
      movePanel(hwnd) ;
      break ;

    case WM_HSCROLL:
      {
        bool changed=true ;

        switch( LOWORD(wp) ){
        case SB_LINELEFT :
          rollinfo_H.nPos -=rollstepH ;
          if( rollinfo_H.nPos < 0 ) rollinfo_H.nPos=0 ;
          break ;
        case SB_LINERIGHT :
          rollinfo_H.nPos +=rollstepH ;
          if( rollinfo_H.nPos > rollinfo_H.nMax ) rollinfo_H.nPos=rollinfo_H.nMax ;
          break ;
        case SB_PAGELEFT :
          rollinfo_H.nPos -= rollinfo_H.nPage/2 ;
          if( rollinfo_H.nPos < 0 ) rollinfo_H.nPos=0 ;
          break ;
        case SB_PAGERIGHT :
          rollinfo_H.nPos += rollinfo_H.nPage/2 ;
          if( rollinfo_H.nPos > rollinfo_H.nMax ) rollinfo_H.nPos=rollinfo_H.nMax ;
          break ;
        case SB_THUMBTRACK :
          {
            SCROLLINFO  tmp_scrinfo ;
            tmp_scrinfo.cbSize = SCROLLINFO.sizeof ; tmp_scrinfo.fMask = SIF_TRACKPOS ;
            GetScrollInfo( hwnd, SB_HORZ, &tmp_scrinfo) ;
            rollinfo_H.nPos = tmp_scrinfo.nTrackPos ;
          }
          break ;

        default:
          changed=false ;
          break ;
        }

        if( changed==true ){
          SetScrollInfo( hwnd, SB_HORZ, &rollinfo_H, true) ;
          movePanel(hwnd) ;
          InvalidateRect(hwnd , null , true);
        }
      }
      break ;

    case WM_VSCROLL:
      {
        bool changed=true ;

        switch( LOWORD(wp) ){
        case SB_LINEUP :
          rollinfo_V.nPos -=rollstepV ;
          if( rollinfo_V.nPos < 0 ) rollinfo_V.nPos=0 ;
          break ;
        case SB_LINEDOWN :
          rollinfo_V.nPos +=rollstepV ;
          if( rollinfo_V.nPos > rollinfo_V.nMax ) rollinfo_V.nPos=rollinfo_V.nMax ;
          break ;
        case SB_PAGEUP :
          rollinfo_V.nPos -= rollinfo_V.nPage/2 ;
          if( rollinfo_V.nPos < 0 ) rollinfo_V.nPos=0 ;
          break ;
        case SB_PAGEDOWN :
          rollinfo_V.nPos += rollinfo_V.nPage/2 ;
          if( rollinfo_V.nPos > rollinfo_V.nMax ) rollinfo_V.nPos=rollinfo_V.nMax ;
          break ;
        case SB_THUMBTRACK :
          {
            SCROLLINFO  tmp_scrinfo ;
            tmp_scrinfo.cbSize = SCROLLINFO.sizeof ; tmp_scrinfo.fMask = SIF_TRACKPOS ;
            GetScrollInfo( hwnd, SB_VERT, &tmp_scrinfo) ;
            rollinfo_V.nPos = tmp_scrinfo.nTrackPos ;
          }
          break ;

        default:
          changed=false ;
          break ;
        }
        if( changed==true ){
          SetScrollInfo( hwnd, SB_VERT, &rollinfo_V, true) ;
          movePanel(hwnd) ;
          InvalidateRect(hwnd , null , true);
        }
      }
      break ;

    case WM_NOTIFY:
    case WM_COMMAND:
      sendmsgtoparent(msg, wp,lp) ;
      break ;

    default : break ;
    }
    return( this.proc(hwnd , msg , wp , lp) ) ;
  }

  private int movePanel(HWND hwnd){
    if( panel is null ) return(-1) ;

    SCROLLINFO  slinfo_H ;
    SCROLLINFO  slinfo_V ;
    slinfo_H.cbSize = SCROLLINFO.sizeof ; slinfo_H.fMask = SIF_POS ;
    slinfo_V.cbSize = SCROLLINFO.sizeof ; slinfo_V.fMask = SIF_POS ;
    GetScrollInfo( hwnd, SB_HORZ, &slinfo_H) ;
    GetScrollInfo( hwnd, SB_VERT, &slinfo_V) ;
    MoveWindow( panel.getHWND(), 0-slinfo_H.nPos, 0-slinfo_V.nPos,
                enbscrollH==true ? scwinW : winW,
                enbscrollV==true ? scwinH : winH, false ) ;
    RedrawWindow( hwnd, null, null, RDW_INVALIDATE|RDW_ALLCHILDREN ) ;
    return(0) ;
  }

}
