import win32.windows;
import std.string;
import std.utf;
import std.stdio;
import win32frame.writek;


class WindowMenu {
  HMENU  hrootmenu ;
  HMENU  hsubmenu[string] ;
  MENUITEMINFO mii;

  this() {
    mii.cbSize  = MENUITEMINFO.sizeof ;
  }

  ~this(){
    destroy() ;
  }

  int create(){
    this.hrootmenu=CreateMenu() ;
    if( this.hrootmenu==null ) return(-1) ;
    return(0)  ;
  }

  int createPopup(){
    this.hrootmenu=CreatePopupMenu() ;
    if( this.hrootmenu==null ) return(-1) ;
    return(0)  ;
  }

  int destroy(){
    DestroyMenu(hrootmenu) ;
    hrootmenu=null ;
    foreach( key ; hsubmenu.keys ){
      hsubmenu.remove(key) ;
    }
    return(0) ;
  }

  int addMenu( UINT type, string item, int id ) {
    if( this.hrootmenu!=null ){
      if( (item in this.hsubmenu)==null ){
        this.hsubmenu[item]=CreateMenu() ;
        if( (item in this.hsubmenu)!=null ){
          mii.fMask   = MIIM_TYPE | MIIM_SUBMENU ;
          mii.fType   = type ;
          mii.hSubMenu= hsubmenu[item] ;
          mii.dwTypeData = toUTFz!(LPWSTR)(item) ;
          InsertMenuItem(hrootmenu, id, FALSE , &mii) ;
        }
      }
      return(0) ;
    }
    return(-1) ;
  }

  int addMenu( string name, UINT type, string item, int id ) {
    if( this.hrootmenu!=null ){
      if( (item in this.hsubmenu)==null ){
        this.hsubmenu[item]=CreateMenu() ;
        if( (item in this.hsubmenu)!=null ){
          mii.fMask   = MIIM_TYPE | MIIM_SUBMENU ;
          mii.fType   = type ;
          mii.hSubMenu= hsubmenu[item] ;
          mii.dwTypeData = toUTFz!(LPWSTR)(item) ;
          InsertMenuItem(hsubmenu[name], id, FALSE , &mii) ;
        }
      }
      return(0) ;
    }
    return(-1) ;
  }

  int addItem( UINT type, string item, int id ) {
    if( this.hrootmenu!=null ){
      mii.fMask   = MIIM_TYPE|MIIM_ID ;
      mii.fType   = type ;
      mii.wID     = id ;
      mii.dwTypeData = toUTFz!(LPWSTR)(item) ;
      InsertMenuItem(hrootmenu, id, FALSE , &mii) ;
      return(0) ;
    }
    return(-1) ;
  }

  int addItem( string name, UINT type, string item, int id ) {
    if( this.hrootmenu!=null ){
      mii.fMask   = MIIM_TYPE|MIIM_ID ;
      mii.fType   = type ;
      mii.wID     = id ;
      mii.dwTypeData = toUTFz!(LPWSTR)(item) ;
      InsertMenuItem(hsubmenu[name], id, FALSE , &mii) ;
      return(0) ;
    }
    return(-1) ;
  }

  int deleteItem( int id ) {
    if( this.hrootmenu!=null ){
      int res=DeleteMenu( this.hrootmenu, id, MF_BYCOMMAND ) ;
      if( res!=0 ){
        return(0) ;
      }
    }
    return(-1) ;
  }

  int deleteItem( string name, int id ) {
    if( this.hrootmenu!=null ){
      int res=DeleteMenu( hsubmenu[name], id, MF_BYCOMMAND ) ;
      if( res!=0 ){
        return(0) ;
      }
    }
    return(-1) ;
  }

  int enableItem( int id , bool enb ) {
    if( this.hrootmenu!=null ){
      int res=EnableMenuItem( this.hrootmenu,id, MF_BYCOMMAND | (enb==true ? MF_ENABLED : MF_GRAYED) ) ;
      return(res) ;
    }
    return(-1) ;
  }

  int enableItem( string name, int id, bool enb ) {
    if( this.hrootmenu!=null ){
      int res=EnableMenuItem( hsubmenu[name], id, MF_BYCOMMAND | (enb==true ? MF_ENABLED : MF_GRAYED) ) ;
      return(res) ;
    }
    return(-1) ;
  }

  HMENU getHMENU(){
    writek("getHMENU=%08x\n",cast(int)(hrootmenu)) ;
    if( this.hrootmenu!=null ){
      return(this.hrootmenu) ;
    }
    return(null) ;
  }

}
